#define INPUT_MAX_LEN 100

#include "main.h"

      program montecarlo
      implicit none
      doubleprecision dummy,enthres
      doubleprecision spectrum(FRSIZE_FREQ,FRSIZE_Y_SMALL)
      doubleprecision tdust(DUST_SIZE_MAX,DUST_SPECIES_MAX,
     %                      FRSIZE_Y_SMALL,FRSIZE_X)
      doubleprecision scatsrc(FRSIZE_FREQ,FRSIZE_Y_SMALL,FRSIZE_X)
      doubleprecision miquant(FRSIZE_FREQ,FRSIZE_Y_SMALL,FRSIZE_X)
      doubleprecision errtol
#     ifdef SAVE_MEANINT
      doubleprecision meanint(FRSIZE_FREQ,FRSIZE_Y_SMALL,FRSIZE_X)
#     else
      doubleprecision meanint
#     endif
      integer inu,nphot,iseed,iformat,imethod,irestart,ir,it,idiff
      integer ispec,cntdump,ifast,itmax,ifile,iredo,i,l
      integer ntemp,nvstr,ivstrt,iterstr,iwarn,ierror_diff
      doubleprecision temp0,temp1,vserrtol,error
      logical fex1,fex2,writescat,iqy,writespec,ierror
      character*160 string
c
#include "common_boundary.h"
#include "common_montecarlo.h"
#include "common_montecarlo_arrays.h"
#include "common_grid.h"
#include "common_dust.h"
#include "common_diffusion.h"
#include "common_vstruct.h"
c
c     Default stuff
c
      ierror_diff=0
      irestart=0
      ifast=0
      enthres=1.d-2
      itempdecoup=1
      iquantum=0
      vserrtol=0.d0
      nvstr=0
      ivstrt=1
      error=0.d0
c
c     New defaults
c
      cntdump=10000000    ! New larger number (08.07.07)
      istarsurf=1         ! Unless old style radmc.inp now istarsurf=1
c
c     If debugging mode, then let the user know...
c
#ifdef MC_DEBUG
      write(*,*) '********************'
      write(*,*) '  DEBUGGING MODE!!'
      write(*,*) '********************'
#endif
c
c     Write a banner:
c
      write(*,*) ' '
      write(*,*) '===============================================',
     %     '================='
      write(*,*) '          ',
     %         'WELCOME TO RADMC: A 2-D CONTINUUM RT SOLVER'
      write(*,*) '===============================================',
     %     '================='
      write(*,*) ' '
c
c     Set some default parameters
c
      nphot   = 100000
      iseed   = -17933201
      imethod = 2
      errtol  = 1d-10
      ntemp   = DB_NTEMP_MAX ! Nr of temperature points in emiss database
      temp0   = 0.01         ! Minimum temperature of emiss database
      temp1   = 1d5          ! Maximum temperature of emiss database
      iredo   = 0
      nphotdiff = 0
c
c     Read radmc.inp 
c
      inquire(file='montecarlo.inp',exist=fex2)
      inquire(file='radmc.inp',exist=fex1)
      if(fex2.and.(.not.fex1)) then
          write(*,*) 'ERROR: The montecarlo.inp is not anymore'
          write(*,*) '       supported. Please use radmc.inp'
          stop
      endif
      if(fex1) then 
          open(unit=1,file='radmc.inp')
          read(1,'(A80)') string
          close(1)
          l=len_trim(string)
          if(l.eq.0) then
              string='a'
              l=1
          endif
          i=0
 10       i=i+1
          if(i.ge.l) goto 15
          if(string(i:i).eq.' ') goto 10
 15       continue
          if((string(i:i).eq.'1').or.(string(i:i).eq.'2').or.
     %       (string(i:i).eq.'3').or.(string(i:i).eq.'4').or.
     %       (string(i:i).eq.'5').or.(string(i:i).eq.'6').or.
     %       (string(i:i).eq.'7').or.(string(i:i).eq.'8').or.
     %       (string(i:i).eq.'9')) then 
c
c             Old formatted style input 
c
c             ...Old defaults
c             
              cntdump   = 10000
              istarsurf = 0
c
c             ...Read data
c
              open(unit=1,file='radmc.inp')
              read(1,*) iformat
              read(1,*) nphot
              read(1,*) dummy   ! For compatibility with other MC code
              read(1,*) iseed
              read(1,*,end=30) imethod
              if(iformat.ge.2) then
                  read(1,*,end=30) ifast
                  read(1,*,end=30) enthres
              endif
              read(1,*,end=30) cntdump
              read(1,*,end=30) irestart
              read(1,*,end=30) itempdecoup ! NEWSTUFF 06-06-04
              read(1,*,end=30) iquantum ! NEWSTUFF 12-12-04
              read(1,*,end=30) istarsurf ! NEWSTUFF 10-11-05
                                         ! =1 means treat finite star size
              read(1,*,end=30) nphotdiff ! Nr of photons below which we
                                         ! will use the diffusion method
                                         ! at the end (0=nodiff)
                                         ! (NEWSTUFF 27.01.07)
              read(1,*,end=30) errtol    ! Error tolerance for diffusion
              if(iformat.ge.3) then
                  read(1,*,end=30) nvstr ! >=1 means do nvstr structure iters
                  read(1,*,end=30) vserrtol ! Error tolerence vstr. If 0.d0, then
                                         ! it will iterate nvstr iterations.
                                         ! Else it will stop before.
                  read(1,*,end=30) ivstrt ! Which dust species represents T_gas
              endif
              read(1,*,end=30) ntemp ! Nr of temperatures in dbase
              read(1,*,end=30) temp0 ! Min temperature in dbase
              read(1,*,end=30) temp1 ! Max temperature in dbase
 30           continue
              close(1)
          else
c
c             New namelist style input
c
              open(unit=1,file='radmc.inp')
              call read_input_file()
              close(1)
              call parse_input_integer('nphot@',nphot)
              call parse_input_integer('iseed@',iseed)
              call parse_input_integer('imethod@',imethod)
              call parse_input_integer('ifast@',ifast)
              call parse_input_double('enthres@',enthres)
              call parse_input_integer('cntdump@',cntdump)
              call parse_input_integer('irestart@',irestart)
              call parse_input_integer('itempdecoup@',itempdecoup)
              call parse_input_integer('iquantum@',iquantum)
              call parse_input_integer('istarsurf@',istarsurf)
              call parse_input_integer('nphotdiff@',nphotdiff)
              call parse_input_double('errtol@',errtol)
              call parse_input_integer('nvstr@',nvstr)
              call parse_input_double('vserrtol@',vserrtol)
              call parse_input_integer('ivstrt@',ivstrt)
              call parse_input_integer('ntemp@',ntemp)
              call parse_input_double('temp0@',temp0)
              call parse_input_double('temp1@',temp1)
              call check_all_lines_ok(ierror)
              if(ierror) stop
          endif
          if(iseed.gt.0) iseed=-iseed
      else
          write(*,*) 'Could not find radmc.inp'
          write(*,*) 'Taking default parameters'
      endif
c
c     Check
c
      if(nvstr.ne.0) then
          inquire(file='chopdens.inp',exist=fex2)
          if(fex2) then
              write(*,*) 'DANGER: The file chopdens.inp is detected'
              write(*,*) '        (making me assume that the chopdens'
              write(*,*) '        code has been employed)'
              write(*,*) '        while the vertical structure mode'
              write(*,*) '        of RADMC is switched on. These'
              write(*,*) '        two things are strongly mutually'
              write(*,*) '        exclusive. Prove to me that no'
              write(*,*) '        chopping has been done by removing'
              write(*,*) '        the chopdens.inp file. '
              write(*,*) '  NOTE: Maybe in the future this is fixed.'
              stop
          endif
      endif
      if((iquantum.lt.0).and.(iquantum.gt.-10)) then
#         ifndef INCLUDE_EMISQUANT
          write(*,*) 'ERROR: If quantum heating switched on,'
          write(*,*) '       you must compile with '
          write(*,*) '       INCLUDE_EMISQUANT'
          stop
#         endif
          if(iquantum.eq.-1) then
              write(*,*) 'WARNING: PAH emission not included as '
              write(*,*) '   heating source for thermal grains.'
              write(*,*) '   Energy is therefore not well conserved.'
              write(*,*) '   Put iquantum to -2 to include it,'
              write(*,*) '   and run RADMC both before and after'
              write(*,*) '   the external PAH code...'
          endif
      endif
      if((iquantum.le.-10).and.(iquantum.gt.-20)) then
#         ifndef INCLUDE_QUANTSOURCENEW
          write(*,*) 'ERROR: If quantum new method switched on,'
          write(*,*) '       you must compile with '
          write(*,*) '       INCLUDE_QUANTSOURCENEW'
          stop
#         endif
      endif
c
c     Message
c
      if(istarsurf.eq.0) then
          write(*,*) 'WARNING: Still using old perfectly radially ',
     %     'outward stellar photons.'
          write(*,*) '         This new version of RADMC allows for ',
     %     'treatment of finite'
          write(*,*) '         size of star.'
          write(*,*) '         Advice: switch this mode on in the ',
     %     'radmc.inp file'
          write(*,*) '         (see code for details).'
          write(*,*) 
      endif
      if(nvstr.eq.0) then
          write(*,*) 'Doing radiative transfer only (no vertical ',
     %               'structure iteration)'
      else
          write(*,*) 'Will iterate on vertical density structure'
          write(*,*) '(note that this will change the input ',
     %               'file dustdens.inp)'
      endif
      write(*,*) 'Nphot   = ',nphot
      if(imethod.eq.2) then
          write(*,*) 'Using smooth method'
      else
          write(*,*) 'Using discrete method'
      endif
      if(ifast.eq.1) then
          write(*,*) 'NOTE: Using acceleration efficiency 1'
          write(*,*) '      (=approximate method!)'
      elseif(ifast.eq.2) then
          write(*,*) 'NOTE: Using acceleration efficiency 2'
          write(*,*) '      (=approximate method!)'
      endif
      if(nphotdiff.ne.0) then
          write(*,*) 'NOTE: Using diffusion algorithm for cells with '
          write(*,*) '      less than ',nphotdiff,' photons visited'
      endif
c
c     Read the input information
c     
      call read_all()
c
c     Calculate the surface densities of the dust (for the vertical
c     structure calculation, and for some diagnostics)
c
      call calc_sigmadust()
c
c     Write some diagnostics
c
      if(dust_nr_species.gt.1) then
          do ispec=1,dust_nr_species
              write(*,*) 'Dust mass in species ',ispec,' = ',
     %             vstr_massdust(ispec)/1.99d33,' Msun'
          enddo
      endif
      write(*,*) 'Dust mass total = ',
     %             vstr_massdusttot/1.99d33,' Msun'
c
c     Do some stuff for the vertical structure
c
c     NOTE: Only possible for problems that are mirror-symmetric in
c           the equator
c
      if(nvstr.gt.0) then 
c
c         Check one thing
c
          if(nphotdiff.eq.0) then 
              write(*,*) 'ERROR: If you wish to iterate on the '
              write(*,*) '   vertical density structure, then you'
              write(*,*) '   must also enable diffusion by setting'
              write(*,*) '   the nphotdiff to, e.g., 30.'
              stop
          endif
c
c         Find the vstruct.inp file and read it
c
          call read_vstructinp()
c
c         Make a backup copy of dustdens.inp
c
          write(*,*) '...Copying dustdens.inp to dustdens_orig.inp'
          call system('\\cp -f dustdens.inp dustdens_orig.inp')
c
      endif
c
c     If quantum-heated grains are present, but iquantum is not set,
c     then make a big warning
c
      iqy = .false.
      do ispec=1,dust_nr_species
          if(dust_quantum(ispec).ne.0) iqy=.true.
      enddo
      if(iqy.and.(iquantum.eq.0)) then
          write(*,*) '***********************************************'
          write(*,*) '***********************************************'
          write(*,*) '  WARNING: Treatment of quantum-heated grains'
          write(*,*) '  switched off, but some of the opacities are'
          write(*,*) '  marked as quantum-heated grains... They are'
          write(*,*) '  now treated as thermal grains...'
          write(*,*) '***********************************************'
          write(*,*) '***********************************************'
      endif
c
c     Write i-grid
c
      call write_igrid()
c
c     Do iteration over structure (or just do one RT simul if
c     iteration of structure is not required)
c
      do iterstr=0,nvstr
c
c         Message
c
          if(iterstr.ge.1) then
              write(*,*) ' ' 
              write(*,*) '-----------------------------------------',
     %             '-----------------------'
              write(*,*) '=====> Vertical structure iteration ',
     %                     iterstr
              write(*,*) '-----------------------------------------',
     %             '-----------------------'
          endif
c
c         Emergency entry for redoing Monte Carlo
c
          iredo = 0
 300      continue
c
c         Now do the MC
c
          call do_monte_carlo(nphot,spectrum,tdust,scatsrc,miquant,
     %                        meanint,imethod,ifast,enthres,iseed,
     %                        cntdump,irestart,ntemp,temp0,temp1)
c
c         Message
c
          if(radbnd_extlumtot.gt.0.d0) then
              write(*,*) 'L_ext/L_* = ',radbnd_extlumtot/
     %             (radbnd_starlumtot+1d-99)
          endif
          if(nrskips.ne.0) then
             write(*,*) 'Number of photon packages skipped due to ',
     %                  'algorithmic problems = ',nrskips
             write(*,*) '  amounting to ',100d0*nrskips/(1.d0*nphot),
     %                  '% of photon packages lost.'
          endif
c
c         Do diffusion
c
c         NOTE: Only possible for problems that are mirror-symmetric in
c               the equator
c
          if(nphotdiff.gt.0) then
              ifile = 1
              writescat = .false.
              writespec = .false.
c
c             Write the unmodified results to dusttemp_mc.dat
c
              call write_results(ifile,spectrum,tdust,scatsrc,miquant,
     %             meanint,writescat,writespec)
c
c             Call the diffusion routine
c
              itmax = irsi_frsizey/2
              call diffusion(irsi_frsizex,itmax,freq_nr,
     %             rsi_x_c(1,1),
     %             rsi_x_c(1,2),freq_nu,
     %             alpha_a,alpha_s,tdust,errtol,ierror_diff)
c
c             In case of problems with diffusion, then redo the 
c             Monte Carlo once
c
              if(ierror_diff.ne.0) then
                  if(iredo.eq.0) then
                      iredo = 1
                      write(*,*) 'Problem: The diffusion algorithm ',
     %                           'caught a problem.'
                      write(*,*) '   Trying to fix it by redoing ',
     %                           'the Monte Carlo run once more.'
                      ierror_diff = 0
                      goto 300
                  else
                      write(*,*) '#################################',
     %                           '##############'
                      write(*,*) 'ERROR in RADMC: ',
     %                           'The diffusion algorithm has had'
                      write(*,*) '   problems that were not fixed...'
                      write(*,*) '#################################',
     %                           '##############'
                      stop
                  endif
              endif
c
c             Write out a file containing information of the area in which
c             the diffusion was carried out.
c
              do it=1,itmax
                  do ir=1,irsi_frsizex
                      idifcell(it,ir) = 0
                  enddo
              enddo
              do idiff=1,ndiff
                  ir = irdiff(idiff)
                  it = itdiff(idiff)
                  if(ipde(idiff).eq.0) then 
                      idifcell(it,ir) = 1
                  else
                      idifcell(it,ir) = 2
                  endif
              enddo
              open(unit=1,file='diffusion.info')
              write(1,*) 1      ! Format number
              write(1,*) irsi_frsizex,itmax
              write(1,*)
              do it=1,itmax
                  do ir=1,irsi_frsizex
                      write(1,*) idifcell(it,ir)
                  enddo
              enddo
              close(1)
          else
c             
c             Remove the file with the diffusion info, as well as the
c             dusttemp_mc.dat
c
              call system('\\rm -f diffusion.info')
              call system('\\rm -f dusttemp_mc.dat')
          endif
c
c         Write the results
c
          if(imethod.eq.2) then
              writescat=.true.
          else
              writescat=.false.
          endif
          ifile = 0
          writespec = .true.
          call write_results(ifile,spectrum,tdust,scatsrc,miquant,
     %                   meanint,writescat,writespec)
c
c         Dump the photon statistics
c
          call write_photstat()
c
c         Now check if we want to do a vertical structure computation
c         
          if(iterstr.lt.nvstr) then 
c
c             Call the vertical structure integrator, of course only
c             for the species that are flagged to be done. So you
c             can still have an envelope and not flag it for vertical
c             structure iteration.
c
              call vertstruct_integrate(tdust,ivstrt,error,iwarn)
c
c             Check for warnings
c
              if(iwarn.ne.0) then
                  write(*,*) 'WARNING: Grid near midplane too coarse'
                  write(*,*) '  for proper calculation of vert struct.'
              endif
c
c             Write the dust density
c
              call write_dustdens()
c
c             Check for error
c
              write(*,*) 'Error in vertical structure = ',error
              if(error.lt.errtol) then
                  write(*,*) ' '
                  write(*,*) ' '
                  write(*,*) 'Convergence in vertical structure '
                  write(*,*) '   (as measured in rho at the equator)'
                  write(*,*) '   (Error=',error,', errtol=',errtol,')'
                  write(*,*) 'DONE...'
                  goto 950
              endif
          endif
c
      enddo
c
c     Check what is the error in the vertical structure
c
      if(nvstr.gt.0) then
          write(*,*) ' '
          write(*,*) '===============================================',
     %               '================='
          write(*,*) 'Could not get error in vertical structure below ',
     %                   errtol
          write(*,*) 'Final error in vertical structure = ',error
          if(nvstr.ge.4) then 
              write(*,*) 'Tip: This could be due to photon noise ',
     %             'of the Monte Carlo method'
          endif
          write(*,*) '===============================================',
     %               '================='
      else
          write(*,*) 'DONE...'
      endif
 950  continue
c
      end


c     --------------------------------------------------------------
c                     READ THE GRID AND SETUP
c     --------------------------------------------------------------
      subroutine read_all()
      implicit none
      doubleprecision dummy,frq,dum
      integer i,ir,it,nr,nt,ix,iy,itmax,k,j,imirt,inu
      integer iformat,ispec,isize,nnf,idum,nspec,nsize
      logical fex
c
#include "common_grid.h"
#include "common_dust.h"
#include "common_boundary.h"
#include "common_montecarlo.h"
c
c     Read the R grid
c     
      open(unit=3,file='radius.inp',status='old')
      read(3,*) irsi_frsizex
      if(irsi_frsizex.gt.FRSIZE_X) then
          write(*,*) 'ERROR: radius.inp has more radial gridpoints'
          write(*,*) '       than FRSIZE_X. '
          write(*,*) '       Recompile with larger FRSIZE_X'
          stop 13
      endif
      do ix=1,irsi_frsizex
          read(3,*) rsi_x_c(ix,1)
      enddo
      close(3)
c     
c     The boundaries
c
      rsi_x_c(0,1)  = rsi_x_c(1,1)**2 / rsi_x_c(2,1)
      rsi_x_c(-1,1) = rsi_x_c(0,1)**2 / rsi_x_c(1,1)
      rsi_x_c(irsi_frsizex+1,1) = rsi_x_c(irsi_frsizex,1)**2 
     %     / rsi_x_c(irsi_frsizex-1,1)
      rsi_x_c(irsi_frsizex+2,1) = rsi_x_c(irsi_frsizex+1,1)**2 
     %     / rsi_x_c(irsi_frsizex,1)
c
c     The cell interfaces
c
      do ix=0,irsi_frsizex+2
          rsi_x_i(ix,1)  = sqrt(rsi_x_c(ix,1)*rsi_x_c(ix-1,1))
      enddo
c
c     Read Theta grid from file, and recompute all other data. 
c     Beware of the theta mirroring option.
c     
      open(unit=3,file='theta.inp',status='old')
      read(3,*) irsi_frsizey,imirt
      itmax = irsi_frsizey
      do iy=1,itmax
          read(3,*) rsi_x_c(iy,2)
          if(rsi_x_c(iy,2).lt.0.d0) then
              write(*,*) 'ERROR: theta.inp has negative values.'
              stop 13                  
          endif
      enddo
      if(imirt.ne.0) then
          irsi_frsizey = 2*irsi_frsizey
      endif
      if(irsi_frsizey.gt.FRSIZE_Y) then
          write(*,*) 'ERROR: theta.inp has more Theta gridpoints'
          write(*,*) '       than FRSIZE_Y. '
          write(*,*) '       Recompile with larger FRSIZE_Y'
          stop 13
      endif
      if(imirt.ne.0) then
          do iy=1,itmax
              rsi_x_c(2*itmax+1-iy,2) = 
     %             3.14159265359d0 - rsi_x_c(iy,2)
          enddo      
      endif
      close(3)
c
c     Do boundaries right
c
      rsi_x_c(0,2)  = - rsi_x_c(1,2)
      rsi_x_c(-1,2) = - rsi_x_c(2,2)
      rsi_x_c(irsi_frsizey+1,2) = 2 * 3.1415926e0 
     %                  - rsi_x_c(irsi_frsizey,2)
      rsi_x_c(irsi_frsizey+2,2) = 2 * 3.1415926e0 
     %                  - rsi_x_c(irsi_frsizey-1,2)
c         
c     Cell interfaces
c         
      do iy=0,irsi_frsizey+2
          rsi_x_i(iy,2)  = 0.5d0 * ( rsi_x_c(iy-1,2) + 
     %         rsi_x_c(iy,2) )
      enddo
c
c     Read the frequency
c     
      open(unit=1,file='frequency.inp',status='old')
      read(1,*) freq_nr
      if(freq_nr.gt.FRSIZE_FREQ) then
          write(*,*) 'ERROR: frequency.inp has more gridpoints'
          write(*,*) '       than FRSIZE_FREQ. '
          write(*,*) '       Recompile with larger FRSIZE_FREQ'
          stop 13
      endif          
      do inu=1,freq_nr
          read(1,*) freq_nu(inu)
      enddo
      close(1)
c
c     Read the dust opacities
c
      call read_dustdata()
c
c     Read the dust density
c
      open(unit=1,file='dustdens.inp',status='old')
      read(1,*) k,nr,nt,j
      if((nr.ne.irsi_frsizex).or.(nt.ne.irsi_frsizey/2)) stop 721
      if(k.ne.dust_nr_species) then
          write(*,*) 'ERROR: In the dustopac.inp file the number'
          write(*,*) '  of dust species is different from that '
          write(*,*) '  specified in dustdens.inp'
          stop 13
      endif
      do ispec=1,dust_nr_species
          do ir=1,nr
              do it=1,nt
                  read(1,*) dum
                  if(dum.gt.1d-90) then
                      dust_rho(ispec,it,ir) = dum
                  else
                      dust_rho(ispec,it,ir) = 1d-90
                  endif
              enddo
          enddo
      enddo
      close(1)
c
c     Read the stellar information
c
      open(unit=1,file='starinfo.inp',status='old')
      read(1,*) iformat
      read(1,*) radbnd_rstar
      read(1,*) radbnd_mstar
      close(1)
      open(unit=3,file='starspectrum.inp',status='old')
      read(3,*) i
      if(i.ne.freq_nr) then
          write(*,*) 'Sorry, stellar spectrum in starspectrum.inp'
          write(*,*) 'does not have the same number of freqs as ',
     %         'other input files.'
          stop 13
      endif
      if(i.eq.1) then
          read(3,*) frq,dummy
          radbnd_starspec(1) = 3.0308410d36 * 
     %         dummy / radbnd_rstar**2
      else
          do i=1,freq_nr
              read(3,*) frq,dummy 
              if(abs(frq-freq_nu(i))/(frq+freq_nu(i)).gt.1.d-3) then
                  write(*,*) 'PROBLEM: Frequency grid of stellar ',
     %                     'spectrum unequal to frequency.inp'
                  write(*,*) frq,freq_nu(i)
                  stop 13
              endif
c             NOTE: pc^2/pi = 3.0308410d36
              radbnd_starspec(i) = 3.0308410d36 * 
     %             dummy / radbnd_rstar**2
          enddo
          close(3)
      endif
c
c     Read the external radiation field
c
      inquire(file='external_meanint.inp',exist=fex)
      if(.not.fex) then
          write(*,*) 'NOTE: No file external_meanint.inp found.'
          write(*,*) '      Assuming that extradfield=0.0...'
          do inu=1,freq_nr
              radbnd_extspec(inu)=0.d0
          enddo
      else
          write(*,*) 'Found external_meanint.inp. Reading...'
          open(unit=1,file='external_meanint.inp',status='old')
          read(1,*) nnf
          if(nnf.ne.freq_nr) then
              write(*,*) 'ERROR reading external_meanint.inp.'
              write(*,*) '      Nr of freq not equal to that of ',
     %             'frequency.inp'
              stop 
          endif
          do inu=1,freq_nr
              read(1,*) frq,radbnd_extspec(inu)
              if(abs((frq-freq_nu(inu))/(frq+freq_nu(inu)))
     %           .gt.1d-4) then
                  write(*,*) 'ERROR while reading external_meanint.inp.'
                  write(*,*) '      Frequency grid not consistent with'
                  write(*,*) '      that of frequency.inp.'
                  stop
              endif
          enddo
          close(1)
      endif
c
c     Read the internal energy production
c
      inquire(file='qplus.inp',exist=fex)
      if(.not.fex) then
          write(*,*) 'NOTE: No file qplus.inp found.'
          write(*,*) '      Assuming that qplus=0.0...'
          do ir=1,nr
              do it=1,nt
                  qplus(it,ir) = 0.d0
              enddo
          enddo
      else
          write(*,*) 'Found qplus.inp. Reading...'
          open(unit=1,file='qplus.inp',status='old')
          read(1,*) nr,nt
          if((nr.ne.irsi_frsizex).or.(nt.ne.irsi_frsizey/2)) then
              write(*,*) 'ERROR: qplus.inp has different R and/or '
              write(*,*) '       theta grid size as the rest.'
              stop
          endif
          do ir=1,nr
              do it=1,nt
                  read(1,*) dum
                  qplus(it,ir) = dum
              enddo
          enddo
          close(1)
      endif
c
c     Reset the emisloc and emisquant array
c
#     ifdef INCLUDE_EMISLOC
      do inu=1,freq_nr
         do it=1,nt
            do ir=1,nr
               emisloc(inu,it,ir) = 0.d0
            enddo
         enddo
      enddo
#     endif
#     ifdef INCLUDE_EMISQUANT
      do inu=1,freq_nr
         do it=1,nt
            do ir=1,nr
               emisquant(inu,it,ir) = 0.d0
            enddo
         enddo
      enddo
#     endif
#     ifdef INCLUDE_QUANTSOURCENEW
      do it=1,nt
          do ir=1,nr
              do ispec=1,dust_nr_species
                  do isize=1,dust_nr_size(ispec)
                      do inu=1,freq_nr
                          quantsrc(inu,isize,ispec,it,ir) = 0.d0
                      enddo
                  enddo
              enddo
          enddo
      enddo
#     endif
c
c     Read the local spectral energy input due to quantum heated grains
c     Only necessary if externally computed (iquantum<0).
c
c     NEWSTUFF 12-12-04
c
      if(iquantum.lt.0) then
#        ifdef INCLUDE_EMISQUANT
         if((iquantum.le.-2).and.(iquantum.ge.-9)) then
c
c            User wishes to include the PAH emission as heating
c            source for the thermal grains
c
             inquire(file='quantsource.dat',exist=fex)
             if(.not.fex) then
                 write(*,*) 'NOTE: No file quantsource.dat found.'
                 write(*,*) '      Assuming that quantsource=0.0...'
             else
                 write(*,*) 'Found quantsource.dat. Reading...'
                 open(unit=1,file='quantsource.dat',status='old')
                 read(1,*) nnf,nr,nt,idum
                 if((nr.ne.irsi_frsizex).or.(nt.ne.irsi_frsizey/2).or.
     %                (nnf.ne.freq_nr)) then
                     write(*,*) 'ERROR: quantsource.dat has different R'
                     write(*,*) 'and/or theta and/or freq grid size'
                     write(*,*) 'as the rest.'
                     stop
                 endif
                 do inu=1,freq_nr
                     do it=1,nt
                         do ir=1,nr
                             read(1,*) dum
                             emisquant(inu,it,ir) = dum
                         enddo
                     enddo
                 enddo
                 close(1)
             endif
         elseif(iquantum.eq.-11) then
c
c            The new quantum method: read the quantum source in for
c            each individual dust species
c
#            ifdef INCLUDE_QUANTSOURCENEW
             inquire(file='quantsrc.dat',exist=fex)
             if(.not.fex) then
                 write(*,*) 'NOTE: No file quantsrc.dat found.'
                 stop 87376
             else
                 write(*,*) 'Reading quantsrc.dat...'
                 open(unit=1,file='quantsrc.dat',status='old')
                 read(1,*) nnf,nspec,nr,nt,idum
                 if((nr.ne.irsi_frsizex).or.(nt.ne.irsi_frsizey/2).or.
     %                (nnf.ne.freq_nr).or.
     %                (nspec.ne.dust_nr_species)) then
                     write(*,*) 'ERROR: quantsrc.dat has different R'
                     write(*,*) 'and/or theta and/or freq grid size'
                     write(*,*) 'and/or nspec as the rest.'
                     stop
                 endif
                 do ispec=1,dust_nr_species
                     read(1,*) nsize
                     if(nsize.ne.dust_nr_size(ispec)) then
                         write(*,*) 'ERROR: quantsrc.dat has different'
                         write(*,*) 'nsize than the rest.'
                         stop 64664
                     endif
                     do isize=1,dust_nr_size(ispec)
                         do inu=1,freq_nr
                             do it=1,nt
                                 do ir=1,nr
                                     read(1,*) quantsrc(inu,
     %                                    isize,ispec,it,ir)
                                     if(quantsrc(inu,
     %                                    isize,ispec,it,ir).lt.
     %                                    0.d0) then
                                         write(*,*) 'ERROR: ',
     %                                    'negative quantsrc.'
                                         stop 29443
                                     endif
                                 enddo
                             enddo
                         enddo
                     enddo
                 enddo
                 close(1)
c
c                Normalize to \int quantsrc d\nu = 1
c                But only for those grains that are indeed quantum...
c
                 do ir=1,irsi_frsizex
                     do it=1,itmax      
                         do ispec=1,dust_nr_species
                             if(dust_quantum(ispec).ne.0) then 
                                 do isize=1,dust_nr_size(ispec)
                                     dum=0.d0
                                     do inu=1,freq_nr
                                         dum = dum +
     %                                        quantsrc(inu,isize,
     %                                        ispec,it,ir) *
     %                                        dust_freq_wgt(inu)
                                     enddo
                                     if(dum.eq.0.d0) then
                                         write(*,*) 'ERROR: found ',
     %                                    'zero quantsrc... This '
                                         write(*,*) 'has never been ',
     %                                    'visited by a photon...'
                                         write(*,*) 'ir,it = ',ir,it
                                         stop 29445
                                     endif
                                     do inu=1,freq_nr
                                         quantsrc(inu,isize,
     %                                        ispec,it,ir) =
     %                                        quantsrc(inu,isize,
     %                                        ispec,it,ir) / dum
                                     enddo
                                 enddo
                             endif
                         enddo
                     enddo
                 enddo
             endif
#            else
             write(*,*) 'ERROR: New quantum more requires'
             write(*,*) 'recompilation with INCLUDE_QUANTSOURCENEW'
             stop 83344
#            endif
         elseif(iquantum.eq.-1) then
c
c            User does not want the PAH emission included as heating
c            source for the thermal grains. Give minor warning.
c
             write(*,*) 'NOTE: The PAH emission is not included'
             write(*,*) '      as heating source for thermal'
             write(*,*) '      grains (because iquantum.eq.-1)...'
             do inu=1,freq_nr
                 do it=1,nt
                     do ir=1,nr
                         emisquant(inu,it,ir) = 0.d0
                     enddo
                 enddo
             enddo
         endif
#        else
         write(*,*) 'ERROR: quantum switched on, but '
         write(*,*) 'emisquant switched off'
         stop 90101
#        endif
      elseif(iquantum.gt.0) then
         write(*,*) 'Mode iquantum.gt.0 not yet ready...'
         stop 0
      endif
c
c     NEWSTUFF 12-12-04
c
#     ifdef INCLUDE_EMISLOC
      inquire(file='stellarsource.dat',exist=fex)
      if(fex) then
          write(*,*) 'Found stellarsource.dat. Reading...'
          open(unit=1,file='stellarsource.dat',status='old')
          read(1,*) nnf,nr,nt,idum
          if((nr.ne.irsi_frsizex).or.(nt.ne.irsi_frsizey/2).or.
     %         (nnf.ne.freq_nr)) then
              write(*,*) 'ERROR: stellarsource.dat has different R '
              write(*,*) 'and/or theta and/or freq grid size '
              write(*,*) 'as the rest.'
              stop
          endif
          do inu=1,freq_nr
              do it=1,nt
                  do ir=1,nr
                      read(1,*) dum
                      emisloc(inu,it,ir) = dum
                  enddo
              enddo
          enddo
          close(1)
      endif
#     else
      inquire(file='stellarsource.inp',exist=fex)
      if(fex) then
          write(*,*) 'NOTE: File stellarsource.inp found,'
          write(*,*) '      but INCLUDE_EMISLOC not defined...'
          write(*,*) '      Must abort...'
          stop 83441
      endif
#     endif
c
      end



c     --------------------------------------------------------------
c                          WRITE THE I-GRID
c     --------------------------------------------------------------
      subroutine write_igrid()
      implicit none
c
#include "common_grid.h"
c
      integer ix,iy
c
      open(unit=1,file='radius_i.dat')
      write(1,*) irsi_frsizex+1
      do ix=1,irsi_frsizex+1
          write(1,*) rsi_x_i(ix,1)
      enddo
      close(1)
c
      open(unit=1,file='theta_i.dat')
      write(1,*) irsi_frsizey+1
      do iy=1,irsi_frsizey+1
          write(1,*) rsi_x_i(iy,2)
      enddo
      close(1)
c
      end



c     --------------------------------------------------------------
c                          WRITE THE RESULTS
c     --------------------------------------------------------------
      subroutine write_results(ifile,spectrum,tdust,scatsrc,miquant,
     %                         meanint,writescat,writespec)
      implicit none
      integer ifile
      doubleprecision spectrum(FRSIZE_FREQ,FRSIZE_Y_SMALL)
      doubleprecision tdust(DUST_SIZE_MAX,DUST_SPECIES_MAX,
     %                      FRSIZE_Y_SMALL,FRSIZE_X)
      doubleprecision scatsrc(FRSIZE_FREQ,FRSIZE_Y_SMALL,FRSIZE_X)
      doubleprecision miquant(FRSIZE_FREQ,FRSIZE_Y_SMALL,FRSIZE_X)
      doubleprecision meanint(FRSIZE_FREQ,FRSIZE_Y_SMALL,FRSIZE_X)
      logical writescat,fex,writespec
c
#include "common_grid.h"
#include "common_boundary.h"
#include "common_montecarlo.h"
#include "common_dust.h"
c
      doubleprecision dum
      integer inu,it,ir,itmax,imirt,isize,ispec,dummy
c
#ifdef MIRROR_THETA
      itmax = (irsi_frsizey+1)/2
      imirt = 1
#else
      itmax = irsi_frsizey
      imirt = 0
#endif
c
      dummy = 0
      do ispec=1,dust_nr_species
          if(dust_nr_size(ispec).gt.dummy) dummy=dust_nr_size(ispec)
      enddo
c
c     Write dust temperature
c
      open(unit=1,file='dusttemp.info',status='unknown')
      write(1,*) -2
      write(1,*) 1
      write(1,*) dummy
      write(1,*) 1
      write(1,*) 1
      close(1)
      if(ifile.eq.0) then 
          write(*,*) '...Writing dust temperature',
     %               '(dusttemp_final.dat)'
          open(unit=1,file='dusttemp_final.dat',status='unknown')
      else
          write(*,*) '...Writing dust temperature',
     %               '(dusttemp_mc.dat)'
          open(unit=1,file='dusttemp_mc.dat',status='unknown')
      endif
      write(1,*) dust_nr_species,irsi_frsizex,itmax,imirt
      write(1,*)
      do ispec=1,dust_nr_species
          write(1,*) dust_nr_size(ispec)
          do isize=1,dust_nr_size(ispec)
              do ir=1,irsi_frsizex
                  do it=1,itmax      
                      write(1,*) tdust(isize,ispec,it,ir)
                  enddo
              enddo
          enddo
      enddo
      close(1)
c     
c     Write the spectrum
c
      if(writespec) then
          write(*,*) '...Writing Monte-Carlo spectra at all ',
     %               'inclinations (spectrum_all.dat)'
          open(unit=1,file='spectrum_all.dat',status='unknown')
          write(1,*) freq_nr,itmax
          write(1,*) ' '
          do it=1,itmax
              write(1,*) 57.2957795d0 * rsi_x_i(it,2),
     %             57.2957795d0 * rsi_x_i(it+1,2)
              do inu=1,freq_nr
                  if(spectrum(inu,it).gt.1.d-97) then
                      write(1,10) freq_nu(inu),spectrum(inu,it)
                  else
                      write(1,10) freq_nu(inu),0.d0
                  endif
              enddo
          enddo
 10       format(E21.13,1X,E21.13)
          close(1)
      endif
c
c     Write the scattering source
c     
      if(writescat) then
          write(*,*) '...Writing isotropic scattering sources ',
     %               '(scatsource.dat)'
          dum = 0.0795774715457d0
          open(unit=1,file='scatsource.dat',status='unknown')
          write(1,*) freq_nr,irsi_frsizex,itmax,imirt
          write(1,*)
          do inu=1,freq_nr
              do it=1,itmax      
                  do ir=1,irsi_frsizex
                      write(1,*) scatsrc(inu,it,ir)*dum
                  enddo
              enddo
          enddo
          close(1)
      endif
c
c     Write the mean intensity of quantum-heating grains
c
      if(iquantum.lt.0) then
          write(*,*) '...Writing meanint for quantum-heated grains ',
     %               '(meanint_quantum.dat)'
          open(unit=1,file='meanint_quantum.dat')
          write(1,*) freq_nr,irsi_frsizex,itmax,imirt
          write(1,*)
          do inu=1,freq_nr
              do it=1,itmax
                  do ir=1,irsi_frsizex
                      write(1,*) miquant(inu,it,ir)
                  enddo
              enddo
          enddo
          close(1)
      else
          inquire(file='meanint_quantum.dat',exist=fex)
          if(fex) call system('rm -f meanint_quantum.dat')
      endif
c
c     If iquantum is 0, then make sure to remove the quantsource.dat
c
      if(iquantum.eq.0) then
          inquire(file='quantsource.dat',exist=fex)
          if(fex) call system('rm -f quantsource.dat') 
      endif
c
c     Write the meanint (only for analysis purposes)
c     
#     ifdef SAVE_MEANINT
      open(unit=1,file='meanint_radmc.dat')
      write(1,*) freq_nr,irsi_frsizex,itmax,imirt
      write(1,*)
      do inu=1,freq_nr
          do it=1,itmax
              do ir=1,irsi_frsizex
                  write(1,*) meanint(inu,it,ir)
              enddo
          enddo
      enddo
      close(1)
#     else
      call system('rm -f meanint_radmc.dat')
#     endif
c
      end


c     --------------------------------------------------------------
c                      WRITE PHOTON STATISTICS
c     --------------------------------------------------------------
      subroutine write_photstat
      implicit none
c
#include "common_grid.h"
#include "common_montecarlo.h"
c
      integer ir,it,itmax,imirt
c
#ifdef MIRROR_THETA
      itmax = (irsi_frsizey+1)/2
      imirt = 1
#else
      itmax = irsi_frsizey
      imirt = 0
#endif
c
      open(unit=1,file='photstat.info')
      write(1,*) 1   ! Format nr
      write(1,*) irsi_frsizex,irsi_frsizey/2
      do it=1,itmax
          do ir=1,irsi_frsizex
              write(1,*) iphotcount(it,ir)
          enddo
      enddo
      close(1)
c
      end


c     --------------------------------------------------------------
c                       WRITE THE DUST DENSITY
c     --------------------------------------------------------------
      subroutine write_dustdens()
      implicit none
c
#include "common_grid.h"
#include "common_boundary.h"
#include "common_montecarlo.h"
#include "common_dust.h"
c
      integer it,ir,ispec,nr,nt
c
      nr = irsi_frsizex
      nt = irsi_frsizey/2
c
      write(*,*) '...Writing dust density (dustdens.inp)'
      open(unit=1,file='dustdens.inp')
      write(1,*) dust_nr_species,nr,nt,1
      do ispec=1,dust_nr_species
          do ir=1,nr
              do it=1,nt
                  write(1,*) dust_rho(ispec,it,ir)
              enddo
          enddo
      enddo
      close(1)
c
      end


c     ==============================================================
c                   ROUTINES FOR PARAMETER LIST READING
c     ==============================================================


c     --------------------------------------------------------------
c            READ IN THE ENTIRE INPUT FILE INTO A STRING ARRAY
c     --------------------------------------------------------------
      subroutine read_input_file()
      implicit none
c
      common/parses/inpstring
      character*160 inpstring(INPUT_MAX_LEN)
      common/parsei/nrstring,lineok
      integer nrstring,lineok(INPUT_MAX_LEN)
c
      character*160 string
      integer iline,i
c
      do iline=1,INPUT_MAX_LEN
          read(1,'(A158)',end=10) string
          inpstring(iline) = string
          lineok(iline) = 0
      enddo
      write(*,*) 'Input file contains too many lines...'
      stop
 10   continue
      nrstring=iline-1
c      
      end



c     --------------------------------------------------------------
c         BASIC PARSING ROUTINE: SPLIT STRING INTO NAME AND VALUE
c
c     This routine interprets lines such as
c  
c       ; The following variable is useful:
c       var1   = 5.74d0  ; Here some comments
c
c     The first line is simply ignored (though marked as OK) and
c     the second line would be split into strname='var1' and
c     strvalue='5.74d0' with lenname being 4 and lenvalue being 6.
c     
c     --------------------------------------------------------------
      subroutine parse_name_value(string,strname,lenname,
     %                                   strvalue,lenvalue,icomm)
      implicit none
      character*160 string
      character*80 strname,strvalue
      integer lenname,lenvalue
      logical icomm
c
      integer ilen,i,istart,istop
c
      icomm    = .false.
      strname  = ''
      lenname  = 0
      strvalue = ''
      lenvalue = 0
      ilen     = len_trim(string)
      istart   = 1
      do i=1,ilen-1
          if(string(i:i).eq.' ') then
              istart=i+1
          else
              goto 20
          endif
      enddo
      icomm=.true.
      return
 20   continue
      if(string(istart:istart).eq.';') then
          icomm=.true.
          return
      endif
      if(istart.ge.ilen) return
      do i=istart+1,ilen-1
          if(string(i:i).eq.' ') goto 40
          if(string(i:i).eq.'=') goto 40
      enddo
      return
 40   continue
      istop=i-1
      lenname = istop-istart+1
      if(lenname.gt.80) then
          write(*,*) 'Variable name too long'
          stop
      endif
      strname = string(istart:istop)
      do i=istop+1,ilen-1
          if(string(i:i).eq.'=') goto 50
      enddo
      lenname=0
      strname=''
      lenvalue=0
      strvalue='' 
      return
 50   continue
      istart = i+1
      if(istart.gt.ilen) stop
      do i=istart,ilen
          if(string(i:i).eq.' ') then
              istart=i+1
          else
              goto 60
          endif
      enddo
 60   continue
      do i=istart+1,ilen
          if(string(i:i).eq.';') goto 80
          if(string(i:i).eq.' ') goto 80
      enddo
 80   continue
      istop = i-1
      lenvalue = istop-istart+1
      if(lenvalue.gt.80) then
          write(*,*) 'Value length too long'
          stop
      endif
      strvalue = string(istart:istop)
c
c      write(*,*) '##',strname(1:lenname),'##',strvalue(1:lenvalue),'##'
c     
      end


c     --------------------------------------------------------------
c                         STRING COMPARING
c     --------------------------------------------------------------
      function stringcompare(string1,string2,len)
      implicit none
      character*80 string1,string2
      integer len
      integer i
      logical stringcompare
c
      if(len.gt.80) stop
      if(len.le.0) then
          stringcompare=.false.
          return
      endif
      stringcompare=.true.
      do i=1,len
          if(string1(i:i).ne.string2(i:i)) stringcompare=.false.
      enddo
      return
      end


c     --------------------------------------------------------------
c                       PARSING ROUTINE FOR DOUBLE
c     --------------------------------------------------------------
      subroutine parse_input_double(name,value)
      implicit none
      character*80 name
      doubleprecision value
c
      common/parses/inpstring
      character*160 inpstring(INPUT_MAX_LEN)
      common/parsei/nrstring,lineok
      integer nrstring,lineok(INPUT_MAX_LEN)
c
      integer iline,ichar
      character*80 strname,strvalue
      integer lenname,lenvalue,lenn
      logical stringcompare,found,icomm
c
      found=.false.
      do ichar=2,80
          if(name(ichar:ichar).eq.'@') goto 30
      enddo
      write(*,*) 'INTERNAL ERROR: Keywords must end with @!!!'
      stop
 30   continue
      lenn=ichar-1
      do iline=1,nrstring
          call parse_name_value(inpstring(iline),
     %             strname,lenname,strvalue,lenvalue,icomm)
          if(icomm) then
              lineok(iline) = 1
          elseif(stringcompare(strname,name,lenn).and.
     %           (lenn.eq.lenname)) then
              if(found) then
                  write(*,*) 'Found one parameter more than once'
                  write(*,*) 'in the input file: ',strname(1:lenname)
                  write(*,*) '*** ABORTING ***'
                  stop
              endif
              read(strvalue(1:lenvalue),*) value
              found=.true.
              lineok(iline) = 1
          endif
      enddo
c
      end

c     --------------------------------------------------------------
c                       PARSING ROUTINE FOR INTEGER
c     --------------------------------------------------------------
      subroutine parse_input_integer(name,value)
      implicit none
      character*80 name
      integer value
c
      common/parses/inpstring
      character*160 inpstring(INPUT_MAX_LEN)
      common/parsei/nrstring,lineok
      integer nrstring,lineok(INPUT_MAX_LEN)
c
      integer iline,ichar
      character*80 strname,strvalue
      integer lenname,lenvalue,lenn
      logical stringcompare,found,icomm
c
      found=.false.
      do ichar=2,80
          if(name(ichar:ichar).eq.'@') goto 30
      enddo
      write(*,*) 'INTERNAL ERROR: Keywords must end with @!!!'
      stop
 30   continue
      lenn=ichar-1
      do iline=1,nrstring
          call parse_name_value(inpstring(iline),
     %             strname,lenname,strvalue,lenvalue,icomm)
          if(icomm) then
              lineok(iline) = 1
          elseif(stringcompare(strname,name,lenn).and.
     %           (lenn.eq.lenname)) then
              if(found) then
                  write(*,*) 'Found one parameter more than once'
                  write(*,*) 'in the input file: ',strname(1:lenname)
                  write(*,*) '*** ABORTING ***'
                  stop
              endif
              read(strvalue(1:lenvalue),*) value
              found=.true.
              lineok(iline) = 1
          endif
      enddo
c
      end

c     --------------------------------------------------------------
c                   CHECK IF ALL LINES ARE OK
c     --------------------------------------------------------------
      subroutine check_all_lines_ok(ierror)
      implicit none
      logical ierror
c
      common/parses/inpstring
      character*160 inpstring(INPUT_MAX_LEN)
      common/parsei/nrstring,lineok
      integer nrstring,lineok(INPUT_MAX_LEN)
c
      character*160 string
      integer iline,ilen
c
      ierror = .false.
      do iline=1,nrstring
          if(lineok(iline).eq.0) then
              write(*,*) 'ERROR in input file: variable unknown:'
              ilen = len_trim(inpstring(iline))
              string = inpstring(iline)
              write(*,*) string(1:ilen)
              ierror = .true.
          endif
      enddo
c
      end
